<template>
  <div class="wp-12 wp-layout wp-layout--no-pad wp-layout--form">
    <div class="wp-layout wp-layout--no-pad">
      <wp-dropdown v-model="actionPermission" :items="actionPermissionItems"
        :placeholder="actionPermissionPlaceholder.text"
        :modifiers="['no_cancel', 'in_text', 'primary', 'no_arrow', 'autoselect']"/>
      <div class="wp-layout__text">пользователю</div>
      <wp-dropdown v-model="action" :items="actionItems"
        :placeholder="actionPlaceholder.text" :disabled="!actionPermission"
        :modifiers="['no_cancel', 'in_text', 'primary', 'no_arrow', 'autoselect']"/>
      <wp-dropdown v-model="actionType" :items="actionTypeItems"
        :placeholder="actionTypePlaceholder.text" :disabled="!action"
        :modifiers="['no_cancel', 'in_text', 'primary', 'no_arrow', 'autoselect']"/>
      <wp-dropdown v-if="actionResources.length !== 0" v-model="actionResource"
        :items="actionResources" :placeholder="actionResourcePlaceholder.text"
        :modifiers="['no_cancel', 'in_text', 'primary', 'no_arrow', 'autoselect']"/>
    </div>
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <button class="wp-button wp-button--margin-right" :disabled="!submitAllowed"
        @click="submit">
        Сохранить изменения
      </button>
      <button class="wp-button wp-button--cancel" @click="$emit('close')">
        Отменить
      </button>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex';

import { PermissionsTypes } from '@/shared';

import WpDropdown from '@/components/input/WpDropdown.vue';

export default {
  name: 'RolePermissionBasic',
  components: {
    WpDropdown,
  },
  data() {
    return {
      actionPermissionItems: [{
        prop: 'allow',
        text: 'Разрешить',
      }, {
        prop: 'disallow',
        text: 'Запретить',
      }],
      actionItems: [{
        prop: 'recieve',
        text: 'получать баллы',
      }, {
        prop: 'set',
        text: 'выставлять баллы',
      }, {
        prop: 'full_access',
        text: 'полный доступ к',
      }, {
        prop: 'create',
        text: 'создавать',
      }, {
        prop: 'read',
        text: 'просматривать',
      }, {
        prop: 'update',
        text: 'изменять',
      }, {
        prop: 'delete',
        text: 'удалять',
      }],
      actionTypeItemPersets: {
        'grade.all': {
          prop: 'grade.all',
          text: 'в любых категориях',
        },
        full_access: [{
          prop: 'organization.all',
          text: 'настройкам организации',
        }, {
          prop: 'member.all',
          text: 'участникам',
        }, {
          prop: 'role.all',
          text: 'ролям',
        }, {
          prop: 'reason.all',
          text: 'причинам',
        }, {
          prop: 'category.all',
          text: 'категориям',
        }, {
          prop: 'groups.all',
          text: 'группам',
        }, {
          prop: 'member',
          text: 'участнику',
        }, {
          prop: 'reason',
          text: 'причине',
        }, {
          prop: 'category',
          text: 'категории',
        }, {
          prop: 'group',
          text: 'группе',
        }],
        crud: [{
          prop: 'member.all',
          text: 'любого участника',
        }, {
          prop: 'role.all',
          text: 'любую роль',
        }, {
          prop: 'reason.all',
          text: 'любую причину',
        }, {
          prop: 'category.all',
          text: 'любую категорию',
        }, {
          prop: 'groups.all',
          text: 'любую группу',
        }],
        read: [{
          prop: 'member',
          text: 'участника',
        }, {
          prop: 'reason',
          text: 'причину',
        }, {
          prop: 'category',
          text: 'категорию',
        }, {
          prop: 'groups',
          text: 'группу',
        }],
      },
      rolePermissions: {
        role: null,
        permissions: [],
      },
      actionPermission: undefined,
      action: undefined,
      actionType: undefined,
      actionResource: undefined,
      PermissionsTypes,
    };
  },
  props: {
    data: {
      type: Object,
      default: () => undefined,
    },
    role: {
      type: Object,
      default: () => undefined,
    },
  },
  computed: {
    ...mapState('session', ['selectedOrganization']),
    ...mapState('organization', [
      'organization',
      'members',
      'roles',
      'groups',
      'categories',
      'reasons',
    ]),
    actionPermissionPlaceholder() {
      const { length } = this.actionPermissionItems;
      return this.actionPermissionItems[Math.floor(Math.random() * length)];
    },
    actionPlaceholder() {
      const { length } = this.actionItems;
      const item = this.actionItems[Math.floor(Math.random() * length)];
      return item || this.actionItems[0];
    },
    actionTypePlaceholder() {
      const action = this.action || this.actionPlaceholder.prop;
      const items = this.getActionTypesByAction(action);
      const item = items[Math.floor(Math.random() * items.length)];
      return item || this.actionTypeItemPersets['grade.all'];
    },
    actionResourcePlaceholder() {
      const actionType = this.actionType || this.actionTypePlaceholder.prop;
      const items = this.getActionResourcesByActionType(actionType);
      return items[Math.floor(Math.random() * items.length)];
    },
    actionTypeItems() {
      return this.getActionTypesByAction(this.action);
    },
    actionResources() {
      return this.getActionResourcesByActionType(this.actionType);
    },
    submitAllowed() {
      return !!this.actionPermission && !!this.action
        && (!!this.actionType || this.actionType === null)
        && (this.actionResources.length === 0 || !!this.actionResource);
    },
    resourceID() {
      if (this.actionType) {
        return this.actionType.indexOf('.all') !== -1 ? null : this.actionResource;
      }
      return undefined;
    },
    isAllowed() {
      return this.actionPermission === 'allow';
    },
  },
  methods: {
    ...mapActions('organization', [
      'createRolePermissions',
    ]),
    resetAction() {
      this.actionType = undefined;
      this.actionResource = undefined;
    },
    getPermissionTypeByName(actionType) {
      switch (actionType.split('.')[0]) {
        case 'organization': return PermissionsTypes.Organization;
        case 'member':
        case 'members': return PermissionsTypes.Members;
        case 'role':
        case 'roles': return PermissionsTypes.Roles;
        case 'reason':
        case 'reasons': return PermissionsTypes.Reasons;
        case 'category':
        case 'categories': return PermissionsTypes.Categories;
        case 'group':
        case 'groups': return PermissionsTypes.Groups;
        default: return undefined;
      }
    },
    makeGradePermissions() {
      this.rolePermissions.permissions.push({
        type: PermissionsTypes.Grades,
        resource: this.resourceID,
        self: false,
        create: false,
        read: this.action === 'recieve' && this.isAllowed,
        update: this.action === 'set' && this.isAllowed,
        delete: false,
      });
      if (this.isAllowed) {
        this.rolePermissions.permissions.push({
          type: PermissionsTypes.Categories,
          resource: this.resourceID,
          self: false,
          create: false,
          read: true,
          update: false,
          delete: false,
        });
      }
    },
    makeFullAccessPermissions() {
      this.rolePermissions.permissions.push({
        type: this.getPermissionTypeByName(this.actionType),
        resource: this.resourceID,
        self: false,
        create: this.isAllowed,
        read: this.isAllowed,
        update: this.isAllowed,
        delete: this.isAllowed,
      });
    },
    makeCrudPermissions() {
      this.rolePermissions.permissions.push({
        type: this.getPermissionTypeByName(this.actionType),
        resource: this.resourceID,
        self: false,
        create: this.action === 'create' && this.isAllowed,
        read: this.action === 'read' && this.isAllowed,
        update: this.action === 'update' && this.isAllowed,
        delete: this.action === 'delete' && this.isAllowed,
      });
    },
    makePermissions() {
      switch (this.action) {
        case 'set':
        case 'recieve': {
          this.makeGradePermissions();
          break;
        }
        case 'full_access': {
          this.makeFullAccessPermissions();
          break;
        }
        case 'read':
        case 'create':
        case 'update':
        case 'delete': {
          this.makeCrudPermissions();
          break;
        }
        default: {
          break;
        }
      }
    },
    getActionResourcesByActionType(actionType) {
      const result = [];
      switch (actionType) {
        case 'member': {
          const members = this.members.map(item => ({
            text: `'${item.email}'`,
            prop: item.id,
          }));
          result.push(...members);
          return result;
        }
        case 'reason': {
          const reasons = this.reasons.map(item => ({
            text: `'${item.text}'`,
            prop: item.id,
          }));
          result.push(...reasons);
          return result;
        }
        case 'category': {
          const categories = this.categories.map(item => ({
            text: `'${item.name}'`,
            prop: item.id,
          }));
          result.push(...categories);
          return result;
        }
        case 'group': {
          const groups = this.groups.map(item => ({
            text: `'${item.name}'`,
            prop: item.id,
          }));
          result.push(...groups);
          return result;
        }
        default: return [];
      }
    },
    getActionTypesByAction(action) {
      const result = [];
      switch (action) {
        case 'set':
        case 'recieve': {
          result.push(this.actionTypeItemPersets['grade.all']);
          const categories = this.categories.map(category => ({
            text: `в категории '${category.name}'`,
            prop: category.id,
          }));
          result.push(...categories);
          break;
        }
        case 'full_access': {
          result.push(...this.actionTypeItemPersets.full_access);
          break;
        }
        case 'read': {
          result.push(...this.actionTypeItemPersets.crud);
          result.push(...this.actionTypeItemPersets.read);
          break;
        }
        case 'create':
        case 'update':
        case 'delete': {
          result.push(...this.actionTypeItemPersets.crud);
          break;
        }
        default: {
          return [];
        }
      }
      return result;
    },
    async submit() {
      try {
        this.makePermissions();
        this.rolePermissions.role = this.$props.role.id;
        await this.createRolePermissions(this.rolePermissions);
        this.$toasted.success('Разрешение создано');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
  watch: {
    action() {
      if (this.actionType || this.actionResource || this.actionType === null) {
        this.resetAction();
      }
    },
  },
};
</script>

<style></style>
